
; -------------------------------------------------------------------------
;
; the Dr. rED mEAT proudly presents :
;        Derviche Generator
;
; ::( cODED IN MASM32 v8 STYLe )::
;   ::( RESiSTANCE IS FUTiLE )::
;
; -------------------------------------------------------------------------
;
; mailto: redmeat_rif@yahoo.fr
; url:    http://www.rif.fr.fm
;
; -------------------------------------------------------------------------

include include.inc
include Algo.asm

; ====================================

.code

; 

start:

    invoke GetModuleHandle, NULL                                            ; Routine principale
    mov hInstance, eax

    call main

    invoke ExitProcess, eax

; ====================================

main proc

    Dialog " : Derviche Generator by the Dr. rED mEAT :", "Lucida Console", 10,\
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER,\
            7,\
            50, 50, 250, 36+17+2+24,\
            1024

    DlgStatic " ", SS_CENTER, 1, 1, 243, 10, eStatic

    DlgEdit ES_AUTOHSCROLL or ES_CENTER or WS_TABSTOP or WS_BORDER,                02, 12, 243, 10, eNom
    DlgEdit ES_AUTOHSCROLL or ES_CENTER or WS_TABSTOP or WS_BORDER or ES_READONLY, 12, 23, 223, 10, eSerial

    DlgButton "&Just Do It", 50018000h or BS_DEFPUSHBUTTON, 002+44, 34+2, 50, 15, bCheck
    DlgButton "&See Ya !", 50018000h,                       054+44, 34+2, 50, 15, bQuit
    DlgButton "&About", 50018000h,                          106+44, 34+2, 50, 15, bAbout

    DlgStatic " 2003 the Dr. rED mEAT / RIF", SS_CENTER, 19, 36+15+4, 207, 10, eStatic2

    CallModalDialog hInstance, 0, WndProc, NULL
    ret

main endp

; ====================================

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF (uMsg == WM_DESTROY) || (uMsg == WM_CLOSE)
        invoke EndDialog, hWnd, NULL

    .ELSEIF (uMsg == WM_INITDIALOG)
        invoke LoadIcon, hInstance, 1
        mov hIcon, eax
        invoke SendMessage, hWnd, WM_SETICON, 1, eax
        invoke SetDlgItemText, hWnd, eStatic, ADDR About
        invoke GetDlgItem, hWnd, eStatic2
        invoke EnableWindow, eax, FALSE
        invoke SetTimer, hWnd, Time, 250, NULL

    .ELSEIF (uMsg == WM_TIMER)
        invoke TimerProc, hWnd

    .ELSEIF (uMsg == WM_COMMAND)
        mov eax, wParam

        .IF (ax == bCheck)
            invoke Beep, 0, 0
            invoke Algo, hWnd

        .ELSEIF (ax == eNom)
            invoke SendMessage, lParam, EM_LIMITTEXT, 22, 0

        .ELSEIF (ax == bQuit)
            invoke ExitProcess, NULL

        .ELSEIF (ax == bAbout)
            invoke Beep, 0, 0
            invoke about, hWnd

        .ENDIF

    .ENDIF

    xor eax, eax
    ret

WndProc endp

; ====================================

TimerProc proc hWnd:HWND

@@:     .IF (count == SIZEOF About)
            mov potouch, 0
            mov count, 0

        .ENDIF

        invoke GetDlgItemText, hWnd, eStatic, ADDR About, SIZEOF About
        lea eax, About
        add eax, count

        .IF ((byte ptr [eax] > '@') && (byte ptr [eax] < '['))  || ((byte ptr [eax] > '`') && (byte ptr [eax] < '{'))
            xor byte ptr [eax], 32

            .IF (dword ptr [potouch])
                mov potouch, 0

            .ELSE
                xor byte ptr [eax-1], 32

            .ENDIF

        .ELSE

            .IF !(dword ptr [potouch])            
                xor byte ptr [eax-1], 32
                invoke SetDlgItemText, hWnd, eStatic, ADDR About                

            .ENDIF

            inc potouch
            inc count
            jmp @B

        .ENDIF

        inc count
        invoke SetDlgItemText, hWnd, eStatic, ADDR About
    ret

TimerProc endp

; ====================================

about proc hWnd:HWND

    Dialog " : Derviche Generator :", "Lucida Console", 10,\
            WS_POPUP or WS_SYSMENU or DS_CENTER or WS_BORDER,\
            4,\
            50, 50, 226, 183,\
            1024

    DlgButton "&Aukea Daukea !", 50018000h or BS_DEFPUSHBUTTON, 26+17, 40+23, 138, 15, bQuit2
    DlgButton "the &RIF's mothership" , 50018000h,              41+17, 78+73, 108, 14, eLink1
    DlgButton "&mail the Dr. rED mEAT" , 50018000h,             56+07, 93+73, 098, 14, eLink2

    DlgStatic " ", SS_CENTER, 1, 67+12, 224, 70, eStatic3

    CallModalDialog hInstance, hWnd, AbtProc, NULL
    ret

about endp

; ====================================

AbtProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    LOCAL hDC   :DWORD
    LOCAL hOld  :DWORD
    LOCAL memDC :DWORD
    LOCAL ps    :PAINTSTRUCT

    .IF (uMsg == WM_DESTROY) || (uMsg == WM_CLOSE)
@@:     invoke EndDialog, hWnd, NULL

    .ELSEIF (uMsg == WM_INITDIALOG)
        invoke LoadIcon, hInstance, 1
        mov hIcon, eax
        invoke SendMessage, hWnd, WM_SETICON, 1, eax
        invoke BitmapFromResource, hInstance, Bmp
        mov hBmp, eax
        invoke SetDlgItemText, hWnd, eStatic3, ADDR Message

    .ELSEIF uMsg == WM_LBUTTONDOWN
        invoke SendMessage, hWnd, WM_NCLBUTTONDOWN, HTCAPTION, 0

    .ELSEIF (uMsg == WM_PAINT)
        invoke BeginPaint, hWnd, ADDR ps
        mov hDC, eax
        invoke CreateCompatibleDC, hDC
        mov memDC, eax
        invoke SelectObject, memDC, hBmp
        mov hOld, eax
        invoke BitBlt, hDC, 1, 1, 450, 100, memDC, 0, 0, SRCCOPY
        invoke SelectObject, hDC, hOld
        invoke DeleteDC, memDC
        invoke EndPaint, hWnd, ADDR ps            

    .ELSEIF (uMsg == WM_COMMAND)
        mov eax, wParam

        .IF (ax == bQuit2)
            jmp @B

        .ELSEIF (ax == eLink1)
            invoke ShellExecute, NULL, NULL, ADDR Link1, NULL, NULL, NULL

        .ELSEIF (ax == eLink2)
            invoke ShellExecute, NULL, NULL, ADDR Link2, NULL, NULL, NULL

        .ENDIF

    .ENDIF

    xor eax, eax
    ret

AbtProc endp

; ====================================

end start

; -------------------------------------------------------------------------
; from the Dr. rED mEAT's MASM32 template v 4.5
; -------------------------------------------------------------------------
